diff -NurpP --minimal linux-2.4.24/include/asm-alpha/unistd.h linux-2.4.24-vs1.24/include/asm-alpha/unistd.h
--- linux-2.4.24/include/asm-alpha/unistd.h	Sat Aug  3 02:39:45 2002
+++ linux-2.4.24-vs1.24/include/asm-alpha/unistd.h	Sat Jan 17 05:27:22 2004
@@ -233,6 +233,7 @@
 #define __NR_osf_memcntl	260	/* not implemented */
 #define __NR_osf_fdatasync	261	/* not implemented */
 
+#define __NR_vserver	273
 
 /*
  * Linux-specific system calls begin at 300
diff -NurpP --minimal linux-2.4.24/include/asm-i386/unistd.h linux-2.4.24-vs1.24/include/asm-i386/unistd.h
--- linux-2.4.24/include/asm-i386/unistd.h	Fri Nov 29 00:53:15 2002
+++ linux-2.4.24-vs1.24/include/asm-i386/unistd.h	Sat Jan 17 05:27:22 2004
@@ -258,6 +258,8 @@
 #define __NR_free_hugepages	251
 #define __NR_exit_group		252
 
+#define __NR_vserver	273
+
 /* user-visible error numbers are in the range -1 - -124: see <asm-i386/errno.h> */
 
 #define __syscall_return(type, res) \
diff -NurpP --minimal linux-2.4.24/include/asm-parisc/unistd.h linux-2.4.24-vs1.24/include/asm-parisc/unistd.h
--- linux-2.4.24/include/asm-parisc/unistd.h	Fri Jun 13 16:51:38 2003
+++ linux-2.4.24-vs1.24/include/asm-parisc/unistd.h	Sat Jan 17 05:27:22 2004
@@ -702,7 +702,9 @@
 #define __NR_readahead          (__NR_Linux + 207)
 #define __NR_tkill              (__NR_Linux + 208)
 
-#define __NR_Linux_syscalls     208
+#define __NR_vserver            (__NR_Linux + 273)
+
+#define __NR_Linux_syscalls     274
 
 #define HPUX_GATEWAY_ADDR       0xC0000004
 #define LINUX_GATEWAY_ADDR      0x100
diff -NurpP --minimal linux-2.4.24/include/asm-ppc/unistd.h linux-2.4.24-vs1.24/include/asm-ppc/unistd.h
--- linux-2.4.24/include/asm-ppc/unistd.h	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/include/asm-ppc/unistd.h	Sat Jan 17 05:27:22 2004
@@ -257,6 +257,8 @@
 #endif
 #define __NR_swapcontext	249
 
+#define __NR_vserver	273
+
 #define __NR(n)	#n
 
 /* On powerpc a system call basically clobbers the same registers like a
diff -NurpP --minimal linux-2.4.24/include/asm-ppc64/unistd.h linux-2.4.24-vs1.24/include/asm-ppc64/unistd.h
--- linux-2.4.24/include/asm-ppc64/unistd.h	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/include/asm-ppc64/unistd.h	Sat Jan 17 05:27:22 2004
@@ -244,6 +244,7 @@
 #define __NR_alloc_hugepages	232
 #define __NR_free_hugepages	233
 #define __NR_exit_group		234
+#define __NR_vserver		273
 
 /* On powerpc a system call basically clobbers the same registers like a
  * function call, with the exception of LR (which is needed for the
diff -NurpP --minimal linux-2.4.24/include/asm-sparc/unistd.h linux-2.4.24-vs1.24/include/asm-sparc/unistd.h
--- linux-2.4.24/include/asm-sparc/unistd.h	Fri Jun 13 16:51:38 2003
+++ linux-2.4.24-vs1.24/include/asm-sparc/unistd.h	Sat Jan 17 05:27:22 2004
@@ -272,6 +272,8 @@
 #define __NR_nfsservctl         254
 #define __NR_aplib              255
 
+#define __NR_vserver	273
+
 #define _syscall0(type,name) \
 type name(void) \
 { \
diff -NurpP --minimal linux-2.4.24/include/asm-sparc64/unistd.h linux-2.4.24-vs1.24/include/asm-sparc64/unistd.h
--- linux-2.4.24/include/asm-sparc64/unistd.h	Fri Jun 13 16:51:38 2003
+++ linux-2.4.24-vs1.24/include/asm-sparc64/unistd.h	Sat Jan 17 05:27:22 2004
@@ -274,6 +274,8 @@
 #define __NR_nfsservctl         254
 #define __NR_aplib              255
 
+#define __NR_vserver	273
+
 #define _syscall0(type,name) \
 type name(void) \
 { \
diff -NurpP --minimal linux-2.4.24/include/asm-x86_64/ia32_unistd.h linux-2.4.24-vs1.24/include/asm-x86_64/ia32_unistd.h
--- linux-2.4.24/include/asm-x86_64/ia32_unistd.h	Fri Jun 13 16:51:38 2003
+++ linux-2.4.24-vs1.24/include/asm-x86_64/ia32_unistd.h	Sat Jan 17 05:27:22 2004
@@ -250,6 +250,8 @@
 #define __NR_ia32_sched_setaffinity	241
 #define __NR_ia32_sched_getaffinity	242
 
-#define IA32_NR_syscalls 245
+#define __NR_ia32_vserver	273
+
+#define IA32_NR_syscalls 274
 
 #endif /* _ASM_X86_64_IA32_UNISTD_H_ */
diff -NurpP --minimal linux-2.4.24/include/asm-x86_64/unistd.h linux-2.4.24-vs1.24/include/asm-x86_64/unistd.h
--- linux-2.4.24/include/asm-x86_64/unistd.h	Fri Nov 28 19:26:21 2003
+++ linux-2.4.24-vs1.24/include/asm-x86_64/unistd.h	Sat Jan 17 05:27:22 2004
@@ -500,7 +500,10 @@ __SYSCALL(__NR_restart_syscall, sys_ni_s
 #define __NR_semtimedop		220
 __SYSCALL(__NR_semtimedop, sys_semtimedop)
 
-#define __NR_syscall_max __NR_semtimedop
+#define __NR_vserver	273
+__SYSCALL(__NR_vserver, sys_vserver)
+
+#define __NR_syscall_max __NR_vserver
 
 #ifndef __NO_STUBS
 
diff -NurpP --minimal linux-2.4.24/include/linux/capability.h linux-2.4.24-vs1.24/include/linux/capability.h
--- linux-2.4.24/include/linux/capability.h	Wed Jan 14 01:29:50 2004
+++ linux-2.4.24-vs1.24/include/linux/capability.h	Sat Jan 17 05:27:22 2004
@@ -130,7 +130,8 @@ typedef __u32 kernel_cap_t;
 
 #define CAP_SETPCAP          8
 
-/* Allow modification of S_IMMUTABLE and S_APPEND file attributes */
+/* Allow modification of S_IMMUTABLE_* and S_APPEND file
+   attributes */
 
 #define CAP_LINUX_IMMUTABLE  9
 
@@ -231,6 +232,7 @@ typedef __u32 kernel_cap_t;
 /* Allow enabling/disabling tagged queuing on SCSI controllers and sending
    arbitrary SCSI commands */
 /* Allow setting encryption key on loopback filesystem */
+/* Allow the selection of a security context */
 
 #define CAP_SYS_ADMIN        21
 
@@ -278,6 +280,15 @@ typedef __u32 kernel_cap_t;
 /* Allow taking of leases on files */
 
 #define CAP_LEASE            28
+
+/* Allow quotactl */
+
+#define CAP_QUOTACTL         29
+
+/* Allow context manipulations */
+/* Allow changing context info on files */
+
+#define CAP_CONTEXT          30
 
 #ifdef __KERNEL__
 /* 
diff -NurpP --minimal linux-2.4.24/include/linux/devpts_fs_info.h linux-2.4.24-vs1.24/include/linux/devpts_fs_info.h
--- linux-2.4.24/include/linux/devpts_fs_info.h	Thu Jan  1 01:00:00 1970
+++ linux-2.4.24-vs1.24/include/linux/devpts_fs_info.h	Sat Jan 17 05:27:22 2004
@@ -0,0 +1,4 @@
+struct devpts_inode_info {
+	int vx_id;
+};
+
diff -NurpP --minimal linux-2.4.24/include/linux/ext2_fs.h linux-2.4.24-vs1.24/include/linux/ext2_fs.h
--- linux-2.4.24/include/linux/ext2_fs.h	Wed Jan 14 01:29:51 2004
+++ linux-2.4.24-vs1.24/include/linux/ext2_fs.h	Sat Jan 17 05:27:22 2004
@@ -187,7 +187,7 @@ struct ext2_group_desc
 #define	EXT2_UNRM_FL			0x00000002 /* Undelete */
 #define	EXT2_COMPR_FL			0x00000004 /* Compress file */
 #define EXT2_SYNC_FL			0x00000008 /* Synchronous updates */
-#define EXT2_IMMUTABLE_FL		0x00000010 /* Immutable file */
+#define EXT2_IMMUTABLE_FILE_FL		0x00000010 /* Immutable file */
 #define EXT2_APPEND_FL			0x00000020 /* writes to file may only append */
 #define EXT2_NODUMP_FL			0x00000040 /* do not dump file */
 #define EXT2_NOATIME_FL			0x00000080 /* do not update atime */
@@ -198,10 +198,11 @@ struct ext2_group_desc
 #define EXT2_ECOMPR_FL			0x00000800 /* Compression error */
 /* End compression flags --- maybe not all used */	
 #define EXT2_BTREE_FL			0x00001000 /* btree format dir */
+#define EXT2_IMMUTABLE_LINK_FL		0x00008000 /* Immutable link */
 #define EXT2_RESERVED_FL		0x80000000 /* reserved for ext2 lib */
 
-#define EXT2_FL_USER_VISIBLE		0x00001FFF /* User visible flags */
-#define EXT2_FL_USER_MODIFIABLE		0x000000FF /* User modifiable flags */
+#define EXT2_FL_USER_VISIBLE		0x00009FFF /* User visible flags */
+#define EXT2_FL_USER_MODIFIABLE		0x000080FF /* User modifiable flags */
 
 /*
  * ioctl commands
diff -NurpP --minimal linux-2.4.24/include/linux/ext3_fs.h linux-2.4.24-vs1.24/include/linux/ext3_fs.h
--- linux-2.4.24/include/linux/ext3_fs.h	Sat Jan 10 15:48:59 2004
+++ linux-2.4.24-vs1.24/include/linux/ext3_fs.h	Sat Jan 17 05:27:22 2004
@@ -190,7 +190,7 @@ struct ext3_group_desc
 #define	EXT3_UNRM_FL			0x00000002 /* Undelete */
 #define	EXT3_COMPR_FL			0x00000004 /* Compress file */
 #define EXT3_SYNC_FL			0x00000008 /* Synchronous updates */
-#define EXT3_IMMUTABLE_FL		0x00000010 /* Immutable file */
+#define EXT3_IMMUTABLE_FILE_FL		0x00000010 /* Immutable file */
 #define EXT3_APPEND_FL			0x00000020 /* writes to file may only append */
 #define EXT3_NODUMP_FL			0x00000040 /* do not dump file */
 #define EXT3_NOATIME_FL			0x00000080 /* do not update atime */
@@ -203,10 +203,11 @@ struct ext3_group_desc
 #define EXT3_INDEX_FL			0x00001000 /* hash-indexed directory */
 #define EXT3_IMAGIC_FL			0x00002000 /* AFS directory */
 #define EXT3_JOURNAL_DATA_FL		0x00004000 /* file data should be journaled */
+#define EXT3_IMMUTABLE_LINK_FL		0x00008000 /* Immutable link */
 #define EXT3_RESERVED_FL		0x80000000 /* reserved for ext3 lib */
 
-#define EXT3_FL_USER_VISIBLE		0x00005FFF /* User visible flags */
-#define EXT3_FL_USER_MODIFIABLE		0x000000FF /* User modifiable flags */
+#define EXT3_FL_USER_VISIBLE		0x0000DFFF /* User visible flags */
+#define EXT3_FL_USER_MODIFIABLE		0x000080FF /* User modifiable flags */
 
 /*
  * Inode dynamic state flags
diff -NurpP --minimal linux-2.4.24/include/linux/fs.h linux-2.4.24-vs1.24/include/linux/fs.h
--- linux-2.4.24/include/linux/fs.h	Sat Jan 10 15:46:51 2004
+++ linux-2.4.24-vs1.24/include/linux/fs.h	Sat Jan 17 05:27:22 2004
@@ -132,9 +132,10 @@ extern int leases_enable, dir_notify_ena
 #define S_NOATIME	2	/* Do not update access times */
 #define S_QUOTA		4	/* Quota initialized for file */
 #define S_APPEND	8	/* Append-only file */
-#define S_IMMUTABLE	16	/* Immutable file */
+#define S_IMMUTABLE_FILE	16	/* Immutable file */
 #define S_DEAD		32	/* removed, but still open directory */
 #define S_NOQUOTA	64	/* Inode is not counted to quota */
+#define S_IMMUTABLE_LINK	128	/* Immutable links */
 
 /*
  * Note that nosuid etc flags are inode-specific: setting some file-system
@@ -158,7 +159,8 @@ extern int leases_enable, dir_notify_ena
 #define IS_QUOTAINIT(inode)	((inode)->i_flags & S_QUOTA)
 #define IS_NOQUOTA(inode)	((inode)->i_flags & S_NOQUOTA)
 #define IS_APPEND(inode)	((inode)->i_flags & S_APPEND)
-#define IS_IMMUTABLE(inode)	((inode)->i_flags & S_IMMUTABLE)
+#define IS_IMMUTABLE_FILE(inode)	((inode)->i_flags & S_IMMUTABLE_FILE)
+#define IS_IMMUTABLE_LINK(inode) ((((inode)->i_flags & S_IMMUTABLE_FILE) << 3) ^ ((inode)->i_flags & S_IMMUTABLE_LINK) )
 #define IS_NOATIME(inode)	(__IS_FLG(inode, MS_NOATIME) || ((inode)->i_flags & S_NOATIME))
 #define IS_NODIRATIME(inode)	__IS_FLG(inode, MS_NODIRATIME)
 
@@ -322,6 +324,7 @@ extern void set_bh_page(struct buffer_he
 #include <linux/usbdev_fs_i.h>
 #include <linux/jffs2_fs_i.h>
 #include <linux/cramfs_fs_sb.h>
+#include <linux/devpts_fs_info.h>
 
 /*
  * Attribute flags.  These should be or-ed together to figure out what
@@ -366,8 +369,9 @@ struct iattr {
 #define ATTR_FLAG_SYNCRONOUS	1 	/* Syncronous write */
 #define ATTR_FLAG_NOATIME	2 	/* Don't update atime */
 #define ATTR_FLAG_APPEND	4 	/* Append-only file */
-#define ATTR_FLAG_IMMUTABLE	8 	/* Immutable file */
+#define ATTR_FLAG_IMMUTABLE_FILE	8	/* Immutable file */
 #define ATTR_FLAG_NODIRATIME	16 	/* Don't update atime for directory */
+#define ATTR_FLAG_IMMUTABLE_LINK	32	/* Immutable file */
 
 /*
  * Includes for diskquotas and mount structures.
@@ -517,6 +521,7 @@ struct inode {
 		struct socket			socket_i;
 		struct usbdev_inode_info        usbdev_i;
 		struct jffs2_inode_info		jffs2_i;
+		struct devpts_inode_info	devpts_i;
 		void				*generic_ip;
 	} u;
 };
diff -NurpP --minimal linux-2.4.24/include/linux/major.h linux-2.4.24-vs1.24/include/linux/major.h
--- linux-2.4.24/include/linux/major.h	Fri Jun 13 16:51:38 2003
+++ linux-2.4.24-vs1.24/include/linux/major.h	Sat Jan 17 05:27:23 2004
@@ -24,6 +24,7 @@
 #define PTY_SLAVE_MAJOR 3
 #define HD_MAJOR	IDE0_MAJOR
 #define TTY_MAJOR	4
+#define VROOT_MAJOR	4
 #define TTYAUX_MAJOR	5
 #define LP_MAJOR	6
 #define VCS_MAJOR	7
diff -NurpP --minimal linux-2.4.24/include/linux/proc_fs.h linux-2.4.24-vs1.24/include/linux/proc_fs.h
--- linux-2.4.24/include/linux/proc_fs.h	Wed Jan 14 01:29:50 2004
+++ linux-2.4.24-vs1.24/include/linux/proc_fs.h	Sat Jan 17 05:27:22 2004
@@ -58,6 +58,7 @@ struct proc_dir_entry {
 	nlink_t nlink;
 	uid_t uid;
 	gid_t gid;
+	int vx_flags;
 	unsigned long size;
 	struct inode_operations * proc_iops;
 	struct file_operations * proc_fops;
diff -NurpP --minimal linux-2.4.24/include/linux/reiserfs_fs.h linux-2.4.24-vs1.24/include/linux/reiserfs_fs.h
--- linux-2.4.24/include/linux/reiserfs_fs.h	Sat Jan 10 15:54:14 2004
+++ linux-2.4.24-vs1.24/include/linux/reiserfs_fs.h	Sat Jan 17 05:27:22 2004
@@ -866,7 +866,8 @@ struct stat_data_v1
 
 /* we want common flags to have the same values as in ext2,
    so chattr(1) will work without problems */
-#define REISERFS_IMMUTABLE_FL EXT2_IMMUTABLE_FL
+#define REISERFS_IMMUTABLE_FILE_FL EXT2_IMMUTABLE_FILE_FL
+#define REISERFS_IMMUTABLE_LINK_FL EXT2_IMMUTABLE_LINK_FL
 #define REISERFS_APPEND_FL    EXT2_APPEND_FL
 #define REISERFS_SYNC_FL      EXT2_SYNC_FL
 #define REISERFS_NOATIME_FL   EXT2_NOATIME_FL
@@ -883,7 +884,8 @@ struct stat_data_v1
 #define REISERFS_NOTAIL_FL    (0x00008000) /* EXT2_NOTAIL_FL */
 
 /* persistent flags that file inherits from the parent directory */
-#define REISERFS_INHERIT_MASK ( REISERFS_IMMUTABLE_FL |	\
+#define REISERFS_INHERIT_MASK ( REISERFS_IMMUTABLE_FILE_FL |	\
+				REISERFS_IMMUTABLE_LINK_FL |	\
 				REISERFS_SYNC_FL |	\
 				REISERFS_NOATIME_FL |	\
 				REISERFS_NODUMP_FL |	\
diff -NurpP --minimal linux-2.4.24/include/linux/sched.h linux-2.4.24-vs1.24/include/linux/sched.h
--- linux-2.4.24/include/linux/sched.h	Sat Jan 10 15:46:51 2004
+++ linux-2.4.24-vs1.24/include/linux/sched.h	Sat Jan 17 05:27:22 2004
@@ -85,6 +85,7 @@ extern int last_pid;
 #endif
 
 #include <asm/processor.h>
+#include <linux/vcontext.h>
 
 #define TASK_RUNNING		0
 #define TASK_INTERRUPTIBLE	1
@@ -270,6 +271,7 @@ struct user_struct {
 	/* Hash table maintenance information */
 	struct user_struct *next, **pprev;
 	uid_t uid;
+	int vx_id;
 };
 
 #define get_current_user() ({ 				\
@@ -277,6 +279,10 @@ struct user_struct {
 	atomic_inc(&__user->__count);			\
 	__user; })
 
+
+struct context_info;
+struct iproot_info;
+
 extern struct user_struct root_user;
 #define INIT_USER (&root_user)
 
@@ -404,6 +410,11 @@ struct task_struct {
 	unsigned long sas_ss_sp;
 	size_t sas_ss_size;
 	int (*notifier)(void *priv);
+	int vx_id;	/* Process can only deal with other processes */
+			/* with the same vx_id */
+	__u32 cap_bset;	/* Maximum capability of this process and children */
+	struct context_info *s_info;
+	struct iproot_info *ip_info;
 	void *notifier_data;
 	sigset_t *notifier_mask;
 	
@@ -508,6 +519,7 @@ extern struct exec_domain	default_exec_d
     blocked:		{{0}},						\
     alloc_lock:		SPIN_LOCK_UNLOCKED,				\
     journal_info:	NULL,						\
+    cap_bset:		CAP_INIT_EFF_SET,				\
 }
 
 
@@ -572,7 +584,7 @@ static inline void task_release_cpu(stru
 }
 
 /* per-UID process charging. */
-extern struct user_struct * alloc_uid(uid_t);
+extern struct user_struct * alloc_uid(int, uid_t);
 extern void free_uid(struct user_struct *);
 extern void switch_uid(struct user_struct *);
 
diff -NurpP --minimal linux-2.4.24/include/linux/sys.h linux-2.4.24-vs1.24/include/linux/sys.h
--- linux-2.4.24/include/linux/sys.h	Fri Jun 13 16:51:39 2003
+++ linux-2.4.24-vs1.24/include/linux/sys.h	Sat Jan 17 05:27:22 2004
@@ -4,7 +4,7 @@
 /*
  * system call entry points ... but not all are defined
  */
-#define NR_syscalls 270
+#define NR_syscalls 274
 
 /*
  * These are system calls that will be removed at some time
diff -NurpP --minimal linux-2.4.24/include/linux/sysctl.h linux-2.4.24-vs1.24/include/linux/sysctl.h
--- linux-2.4.24/include/linux/sysctl.h	Sat Jan 10 15:46:53 2004
+++ linux-2.4.24-vs1.24/include/linux/sysctl.h	Sat Jan 17 05:27:23 2004
@@ -128,6 +128,7 @@ enum
 	KERN_PPC_L3CR=57,       /* l3cr register on PPC */
 	KERN_EXCEPTION_TRACE=58, /* boolean: exception trace */
  	KERN_CORE_SETUID=59,	/* int: set to allow core dumps of setuid apps */
+	KERN_VSHELPER=60,	/* string: path to vshelper policy agent */
 };
 
 
diff -NurpP --minimal linux-2.4.24/include/linux/vcontext.h linux-2.4.24-vs1.24/include/linux/vcontext.h
--- linux-2.4.24/include/linux/vcontext.h	Thu Jan  1 01:00:00 1970
+++ linux-2.4.24-vs1.24/include/linux/vcontext.h	Sat Jan 17 05:27:22 2004
@@ -0,0 +1,121 @@
+#ifndef _VX_CONTEXT_H
+#define _VX_CONTEXT_H
+
+/*
+	We may have a different domainname and nodename for each security
+	context. By default, a security context share the same as its
+	parent, potentially the information in system_utsname
+*/
+#define VX_INFO_LOCK		1	/* Can't request a new vx_id */
+#define VX_INFO_SCHED		2	/* All process in the vx_id */
+					/* Contribute to the schedular */
+#define VX_INFO_NPROC		4	/* Limit number of processes in a context */
+#define VX_INFO_PRIVATE		8	/* Noone can join this security context */
+#define VX_INFO_INIT		16	/* This process wants to become the */
+					/* logical process 1 of the security */
+					/* context */
+#define VX_INFO_HIDEINFO	32	/* Hide some information in /proc */
+#define VX_INFO_ULIMIT		64	/* Use ulimit of the current process */
+					/* to become the global limits */
+					/* of the context */
+	
+#define MAX_S_CONTEXT 65535	/* Arbitrary limit */
+#define MIN_D_CONTEXT 49152	/* dynamic contexts start here */
+
+#define NB_S_CONTEXT	16
+
+#define NB_IPV4ROOT	16
+
+#include <asm/resource.h>
+#include <asm/atomic.h>
+
+struct context_info {
+	atomic_t refcount;
+	short int vx_id[NB_S_CONTEXT];/* root is allowed to switch the current */
+				/* security context using any in this table */
+	unsigned long rlim[RLIM_NLIMITS];	/* Per context limit */
+	atomic_t res[RLIM_NLIMITS];	/* Current value */
+	struct proc_dir_entry *procent;
+	char nodename[65];
+	char domainname[65];
+	int flags;		/* VX_INFO_xxx */
+	atomic_t ticks;		/* Number of ticks used by all process */
+				/* in the vx_id */
+	int initpid;		/* PID of the logical process 1 of the */
+				/* of the context */
+	int nr_threads;
+	unsigned long total_forks;
+	unsigned int bias_cswtch;
+	long bias_jiffies;
+	long bias_idle;
+	void *data1;
+	void *data2;
+	void *data3;
+	void *data4;
+};
+
+struct iproot_info {
+	unsigned long mark;	/* Special signature for debugging */
+	atomic_t refcount;
+	int nbipv4;
+	__u32 ipv4[NB_IPV4ROOT];/* Process can only bind to these IPs */
+				/* The first one is used to connect */
+				/* and for bind any service */
+				/* The other must be used explicity when */
+				/* binding */
+	__u32 mask[NB_IPV4ROOT];/* Netmask for each ipv4 */
+				/* Used to select the proper source address */
+				/* for sockets */
+	__u32 v4_bcast;	/* Broadcast address used to receive UDP packets */
+};
+
+
+#define	VX_ADMIN	0x0001
+#define	VX_WATCH	0x0002
+
+#define	VX_IDENT	0x0010
+#define	VX_EQUIV	0x0020
+#define	VX_PARENT	0x0040
+#define	VX_CHILD	0x0080
+
+#define	VX_ARG_MASK	0x00F0
+
+#include <asm/current.h>
+
+/* required to resolve recursive dependancies */
+#define vx_check(c,m)	__vx_check(current->vx_id,c,m)
+
+#define vx_weak_check(c,m)     ((m) ? vx_check(c,m) : 1)
+
+/*
+ * check current context for ADMIN/WATCH and
+ * optionally agains supplied argument
+ */
+static inline int __vx_check(int cctx, int ctx, unsigned int mode)
+{
+	if (mode & VX_ARG_MASK) {
+		if ((mode & VX_IDENT) && (ctx == cctx))
+			return 1;
+		if ((mode & VX_EQUIV) && (ctx == cctx))
+			return 1;
+	}
+	return (((mode & VX_ADMIN) && (cctx == 0)) ||
+		((mode & VX_WATCH) && (cctx == 1)));
+}
+
+
+void vx_assign_info(struct task_struct *);
+void vx_release_info(struct task_struct *);
+
+void vx_assign_ip_info(struct iproot_info *);
+void vx_release_ip_info(struct iproot_info *);
+
+int vc_new_s_context(uint32_t, void *);
+int vc_set_ipv4root(uint32_t, void *);
+
+/* procfs ioctls */
+
+#define	FIOC_GETXFLG	_IOR('x', 5, long)
+#define	FIOC_SETXFLG	_IOW('x', 6, long)
+
+#endif
diff -NurpP --minimal linux-2.4.24/include/linux/vswitch.h linux-2.4.24-vs1.24/include/linux/vswitch.h
--- linux-2.4.24/include/linux/vswitch.h	Thu Jan  1 01:00:00 1970
+++ linux-2.4.24-vs1.24/include/linux/vswitch.h	Sat Jan 17 05:27:22 2004
@@ -0,0 +1,122 @@
+#ifndef _LINUX_VIRTUAL_H
+#define _LINUX_VIRTUAL_H
+
+#include <linux/types.h>
+#include <linux/vcontext.h>
+
+#define VC_CATEGORY(c)		(((c) >> 24) & 0x3F)
+#define VC_COMMAND(c)		(((c) >> 16) & 0xFF)
+#define VC_VERSION(c)		((c) & 0xFFF)
+
+#define VC_CMD(c,i,v)		((((VC_CAT_ ## c) & 0x3F) << 24) \
+				| (((i) & 0xFF) << 16) | ((v) & 0xFFF))
+
+/*
+
+  Syscall Matrix V2.3
+
+         |VERSION|CREATE |MODIFY |MIGRATE|CONTROL|EXPERIM| |SPECIAL|SPECIAL|
+         |STATS  |DESTROY|ALTER  |CHANGE |LIMIT  |TEST   | |       |       |
+         |INFO   |SETUP  |       |MOVE   |       |       | |       |       |
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  SYSTEM |VERSION|       |       |       |       |       | |DEVICES|       |
+  HOST   |     00|     01|     02|     03|     04|     05| |     06|     07|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  CPU    |       |       |       |       |       |       | |SCHED. |       |
+  PROCESS|     08|     09|     10|     11|     12|     13| |     14|     15|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  MEMORY |       |       |       |       |       |       | |SWAP   |       |
+         |     16|     17|     18|     19|     20|     21| |     22|     23|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  NETWORK|       |       |       |       |       |       | |SERIAL |       |
+         |     24|     25|     26|     27|     28|     29| |     30|     31|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  DISK   |       |       |       |       |       |       | |       |       |
+  VFS    |     32|     33|     34|     35|     36|     37| |     38|     39|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  OTHER  |       |       |       |       |       |       | |       |       |
+         |     40|     41|     42|     43|     44|     45| |     46|     47|
+  =======+=======+=======+=======+=======+=======+=======+ +=======+=======+
+  SPECIAL|       |       |       |       |       |       | |       |       |
+         |     48|     49|     50|     51|     52|     53| |     54|     55|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+  SPECIAL|       |       |       |       |RLIMIT |SYSCALL| |       |COMPAT |
+         |     56|     57|     58|     59|     60|TEST 61| |     62|     63|
+  -------+-------+-------+-------+-------+-------+-------+ +-------+-------+
+
+*/
+
+#define VC_CAT_VERSION		0
+	
+#define VC_CAT_PROCTRL		12
+
+#define VC_CAT_RLIMIT		60
+
+#define VC_CAT_SYSTEST		61
+#define VC_CAT_COMPAT		63
+	
+/*  interface version */
+
+#define VCI_VERSION		0x00010004
+
+
+
+/*  query version */
+
+#define VCMD_get_version	VC_CMD(VERSION, 0, 0)
+
+
+/*  compatibiliy vserver commands */
+
+#define VCMD_new_s_context	VC_CMD(COMPAT, 1, 1)
+#define VCMD_set_ipv4root	VC_CMD(COMPAT, 2, 3)
+
+/*  compatibiliy vserver arguments */
+
+struct  vcmd_new_s_context_v1 {
+	uint32_t remove_cap;
+	uint32_t flags;
+};
+
+struct  vcmd_set_ipv4root_v3 {
+	/* number of pairs in id */
+	uint32_t broadcast;
+	struct {
+		uint32_t ip;
+		uint32_t mask;
+	} ip_mask_pair[NB_IPV4ROOT];
+};
+
+/*  context signalling */
+
+#define VCMD_ctx_kill		VC_CMD(PROCTRL, 1, 0)
+
+struct  vcmd_ctx_kill_v0 {
+	int32_t pid;
+	int32_t sig;
+};
+
+/*  rlimit vserver commands */
+
+#define VCMD_get_rlimit		VC_CMD(RLIMIT, 1, 0)
+#define VCMD_set_rlimit		VC_CMD(RLIMIT, 2, 0)
+#define VCMD_get_rlimit_mask	VC_CMD(RLIMIT, 3, 0)
+
+struct  vcmd_ctx_rlimit_v0 {
+	uint32_t id;
+	uint64_t minimum;
+	uint64_t softlimit;
+	uint64_t maximum;
+};
+
+struct  vcmd_ctx_rlimit_mask_v0 {
+	uint32_t minimum;
+	uint32_t softlimit;
+	uint32_t maximum;
+};
+
+#define CRLIM_INFINITY		(~0ULL)
+#define CRLIM_KEEP		(~1ULL)
+
+
+#endif /* _LINUX_VIRTUAL_H */
diff -NurpP --minimal linux-2.4.24/include/net/ip.h linux-2.4.24-vs1.24/include/net/ip.h
--- linux-2.4.24/include/net/ip.h	Wed Jan 14 02:09:13 2004
+++ linux-2.4.24-vs1.24/include/net/ip.h	Sat Jan 17 05:27:22 2004
@@ -29,6 +29,7 @@
 #include <linux/netdevice.h>
 #include <linux/inetdevice.h>
 #include <linux/in_route.h>
+#include <linux/vcontext.h>
 #include <net/route.h>
 #include <net/arp.h>
 
diff -NurpP --minimal linux-2.4.24/include/net/route.h linux-2.4.24-vs1.24/include/net/route.h
--- linux-2.4.24/include/net/route.h	Sat Jan 10 15:47:59 2004
+++ linux-2.4.24-vs1.24/include/net/route.h	Sat Jan 17 05:27:23 2004
@@ -32,6 +32,7 @@
 #include <linux/route.h>
 #include <linux/ip.h>
 #include <linux/cache.h>
+#include <linux/vcontext.h>
 
 #ifndef __KERNEL__
 #warning This file is not supposed to be used outside of kernel.
@@ -166,6 +167,44 @@ static inline char rt_tos2priority(u8 to
 static inline int ip_route_connect(struct rtable **rp, u32 dst, u32 src, u32 tos, int oif)
 {
 	int err;
+	struct iproot_info *ip_info = current->ip_info;
+	if (ip_info != NULL) {
+		__u32 ipv4root = ip_info->ipv4[0];
+		if (ipv4root != 0) {
+			int n = ip_info->nbipv4;
+			if (src == 0) {
+				if (n > 1) {
+					u32 foundsrc;
+					int i;
+					err = ip_route_output(rp, dst, src, tos, oif);
+					if (err) return err;
+					foundsrc = (*rp)->rt_src;
+					ip_rt_put(*rp);
+					for (i=0; i<n; i++){
+						u32 mask = ip_info->mask[i];
+						u32 ipv4 = ip_info->ipv4[i];
+						u32 netipv4 = ipv4 & mask;
+						if ((foundsrc & mask) == netipv4) {
+							src = ipv4;
+							break;
+						}
+					}
+				}
+				if (src == 0)
+					src = dst == 0x0100007f
+						? 0x0100007f: ipv4root;
+			} else {
+				int i;
+				for (i=0; i<n; i++) {
+					if (ip_info->ipv4[i] == src) break;
+				}
+				if (i == n)
+					return -EPERM;
+			}
+			if (dst == 0x0100007f && !vx_check(0, VX_ADMIN))
+				dst = ipv4root;
+		}
+	}
 	err = ip_route_output(rp, dst, src, tos, oif);
 	if (err || (dst && src))
 		return err;
diff -NurpP --minimal linux-2.4.24/include/net/sock.h linux-2.4.24-vs1.24/include/net/sock.h
--- linux-2.4.24/include/net/sock.h	Sat Jan 10 15:47:59 2004
+++ linux-2.4.24-vs1.24/include/net/sock.h	Sat Jan 17 05:27:23 2004
@@ -501,6 +501,7 @@ do {	spin_lock_init(&((__sk)->lock.slock
 } while(0)
 
 struct sock {
+	/* See tcp.h comment on tcp_tw_bucket */
 	/* Socket demultiplex comparisons on incoming packets. */
 	__u32			daddr;		/* Foreign IPv4 addr			*/
 	__u32			rcv_saddr;	/* Bound local IPv4 addr		*/
@@ -522,6 +523,8 @@ struct sock {
 	unsigned char		reuse;		/* SO_REUSEADDR setting			*/
 	unsigned char		shutdown;
 	atomic_t		refcnt;		/* Reference count			*/
+	struct iproot_info	*ip_info;
+	/* End of common section with tcp_tw_bucket */
 
 	socket_lock_t		lock;		/* Synchronizer...			*/
 	int			rcvbuf;		/* Size of receive buffer in bytes	*/
@@ -539,6 +542,7 @@ struct sock {
 	__u32			saddr;		/* Sending source			*/
 	unsigned int		allocation;	/* Allocation mode			*/
 	int			sndbuf;		/* Size of send buffer in bytes		*/
+	__u32			rcv_saddr2;	/* Second bound ipv4 addr, for ipv4root */
 	struct sock		*prev;
 
 	/* Not all are volatile, but some are, so we might as well say they all are.
@@ -686,6 +690,9 @@ struct sock {
 	/* RPC layer private data */
 	void			*user_data;
   
+	/* Context of process creating this socket */
+	int			vx_id;
+
 	/* Callbacks */
 	void			(*state_change)(struct sock *sk);
 	void			(*data_ready)(struct sock *sk,int bytes);
diff -NurpP --minimal linux-2.4.24/include/net/tcp.h linux-2.4.24-vs1.24/include/net/tcp.h
--- linux-2.4.24/include/net/tcp.h	Sat Jan 10 15:50:19 2004
+++ linux-2.4.24-vs1.24/include/net/tcp.h	Sat Jan 17 05:27:23 2004
@@ -173,6 +173,7 @@ struct tcp_tw_bucket {
 	unsigned char		reuse,
 				rcv_wscale; /* It is also TW bucket specific */
 	atomic_t		refcnt;
+	struct ipv4_info	*ip_info;
 
 	/* And these are ours. */
 	int			hashent;
@@ -191,6 +192,7 @@ struct tcp_tw_bucket {
 	struct in6_addr		v6_daddr;
 	struct in6_addr		v6_rcv_saddr;
 #endif
+	int			vx_id;
 };
 
 extern kmem_cache_t *tcp_timewait_cachep;
diff -NurpP --minimal linux-2.4.24/ipc/util.c linux-2.4.24-vs1.24/ipc/util.c
--- linux-2.4.24/ipc/util.c	Mon Aug 25 13:44:44 2003
+++ linux-2.4.24-vs1.24/ipc/util.c	Sat Jan 17 05:27:23 2004
@@ -93,6 +93,8 @@ int ipc_findkey(struct ipc_ids* ids, key
 	struct kern_ipc_perm* p;
 
 	for (id = 0; id <= ids->max_id; id++) {
+		if (!vx_check(ids->entries[id].vx_id, VX_IDENT))
+			continue;
 		p = ids->entries[id].p;
 		if(p==NULL)
 			continue;
@@ -167,6 +169,7 @@ found:
 
 	spin_lock(&ids->ary);
 	ids->entries[id].p = new;
+	ids->entries[id].vx_id = current->vx_id;
 	return id;
 }
 
diff -NurpP --minimal linux-2.4.24/ipc/util.h linux-2.4.24-vs1.24/ipc/util.h
--- linux-2.4.24/ipc/util.h	Fri Nov 29 00:53:15 2002
+++ linux-2.4.24-vs1.24/ipc/util.h	Sat Jan 17 05:27:22 2004
@@ -5,6 +5,8 @@
  * ipc helper functions (c) 1999 Manfred Spraul <manfreds@colorfullife.com>
  */
 
+#include <linux/vcontext.h>
+
 #define USHRT_MAX 0xffff
 #define SEQ_MULTIPLIER	(IPCMNI)
 
@@ -25,6 +27,7 @@ struct ipc_ids {
 
 struct ipc_id {
 	struct kern_ipc_perm* p;
+	int vx_id;	// Context owning this ID
 };
 
 
@@ -74,8 +77,11 @@ extern inline struct kern_ipc_perm* ipc_
 
 	spin_lock(&ids->ary);
 	out = ids->entries[lid].p;
-	if(out==NULL)
+	if (out==NULL ||
+		!vx_check(ids->entries[lid].vx_id, VX_WATCH|VX_IDENT)) {
 		spin_unlock(&ids->ary);
+		out = NULL;
+	}
 	return out;
 }
 
diff -NurpP --minimal linux-2.4.24/kernel/Makefile linux-2.4.24-vs1.24/kernel/Makefile
--- linux-2.4.24/kernel/Makefile	Mon Sep 17 06:22:40 2001
+++ linux-2.4.24-vs1.24/kernel/Makefile	Sat Jan 17 05:27:22 2004
@@ -14,7 +14,7 @@ export-objs = signal.o sys.o kmod.o cont
 obj-y     = sched.o dma.o fork.o exec_domain.o panic.o printk.o \
 	    module.o exit.o itimer.o info.o time.o softirq.o resource.o \
 	    sysctl.o acct.o capability.o ptrace.o timer.o user.o \
-	    signal.o sys.o kmod.o context.o
+	    signal.o sys.o kmod.o context.o vswitch.o vcontext.o
 
 obj-$(CONFIG_UID16) += uid16.o
 obj-$(CONFIG_MODULES) += ksyms.o
diff -NurpP --minimal linux-2.4.24/kernel/exit.c linux-2.4.24-vs1.24/kernel/exit.c
--- linux-2.4.24/kernel/exit.c	Fri Nov 29 00:53:15 2002
+++ linux-2.4.24-vs1.24/kernel/exit.c	Sat Jan 17 05:27:22 2004
@@ -16,6 +16,7 @@
 #ifdef CONFIG_BSD_PROCESS_ACCT
 #include <linux/acct.h>
 #endif
+#include <linux/vcontext.h>
 
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
@@ -23,6 +24,7 @@
 
 extern void sem_exit (void);
 extern struct task_struct *child_reaper;
+extern rwlock_t ctx_ref_lock;
 
 int getrusage(struct task_struct *, int, struct rusage *);
 
@@ -66,6 +68,8 @@ static void release_task(struct task_str
 		current->counter += p->counter;
 		if (current->counter >= MAX_COUNTER)
 			current->counter = MAX_COUNTER;
+		vx_release_info(p);
+		vx_release_ip_info(p->ip_info);
 		p->pid = 0;
 		free_task_struct(p);
 	} else {
@@ -159,8 +163,20 @@ static inline int has_stopped_jobs(int p
 static inline void forget_original_parent(struct task_struct * father)
 {
 	struct task_struct * p;
+	struct task_struct *vchild_reaper = child_reaper;
 
 	read_lock(&tasklist_lock);
+	read_lock(&ctx_ref_lock);
+	if (father->s_info) {
+		pid_t initpid = father->s_info->initpid;
+		if ((initpid != 0) && (father->pid != initpid)) {
+			struct task_struct *r = find_task_by_pid(initpid);
+
+			if (r != NULL)
+				vchild_reaper = r;
+		}
+	}
+	read_unlock(&ctx_ref_lock);
 
 	for_each_task(p) {
 		if (p->p_opptr == father) {
@@ -169,7 +185,7 @@ static inline void forget_original_paren
 			p->self_exec_id++;
 
 			/* Make sure we're not reparenting to ourselves */
-			p->p_opptr = child_reaper;
+			p->p_opptr = vchild_reaper;
 
 			if (p->pdeath_signal) send_sig(p->pdeath_signal, p, 0);
 		}
